import JSend from 'jsend';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

/**
 * Update an Error with the specified config, error code, and response.
 *
 * @param {Error} error The error to update.
 * @param {Object} config The config.
 * @param {string} [code] The error code (for example, 'ECONNABORTED').
 * @param {Object} [request] The request.
 * @param {Object} [response] The response.
 * @returns {Error} The error.
 */
var enhanceError = function enhanceError(error, config, code, request, response) {
  error.config = config;
  if (code) {
    error.code = code;
  }

  error.request = request;
  error.response = response;
  error.isAxiosError = true;

  error.toJSON = function() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: this.config,
      code: this.code
    };
  };
  return error;
};

var JSendError =
/*#__PURE__*/
function (_Error) {
  _inherits(JSendError, _Error);

  function JSendError(message, _ref) {
    var _this;

    var jsend = _ref.jsend,
        data = _ref.data,
        response = _ref.response;

    _classCallCheck(this, JSendError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(JSendError).call(this, message));
    var config = response.config,
        request = response.request;

    var _enhanceError = enhanceError({}, config, null, request, response),
        _toJSON = _enhanceError.toJSON,
        info = _objectWithoutProperties(_enhanceError, ["toJSON"]);

    Object.assign(_assertThisInitialized(_this), info, {
      jsend: jsend,
      data: data,
      toJSON: function toJSON() {
        var json = _toJSON.call(this);

        return Object.assign(json, {
          jsend: jsend,
          data: data
        });
      }
    });
    return _this;
  }

  _createClass(JSendError, [{
    key: "name",
    get: function get() {
      return this.constructor.name;
    }
  }, {
    key: "isJSendError",
    get: function get() {
      return true;
    }
  }]);

  return JSendError;
}(_wrapNativeSuper(Error));

var JSEND_FIELDS = ['status', 'code', 'data', 'message'];
function apply(axios) {
  return axios.interceptors.response.use(function (response) {
    if (!response.data) return response;
    if (!JSend.isValid(response.data)) return response;

    var _pick = pick(JSEND_FIELDS, response.data),
        data = _pick.data,
        jsend = _objectWithoutProperties(_pick, ["data"]);

    if (jsend.status !== 'success') throw createError(response, {
      jsend: jsend,
      data: data
    });
    Object.assign(response, {
      jsend: jsend,
      data: data
    });
    return response;
  }, function (err) {
    if (!err.response || !err.response.data) throw err;
    if (!JSend.isValid(err.response.data)) throw err;

    var _pick2 = pick(JSEND_FIELDS, err.response.data),
        data = _pick2.data,
        jsend = _objectWithoutProperties(_pick2, ["data"]);

    if (jsend.status !== 'success') throw createError(err.response, {
      jsend: jsend,
      data: data
    });
    Object.assign(err, {
      jsend: jsend,
      data: data
    });
    throw err;
  });
}

function createError(response, _ref) {
  var jsend = _ref.jsend,
      data = _ref.data;
  var options = {
    jsend: jsend,
    data: data,
    response: response
  };

  if (jsend.status === 'fail') {
    return new JSendError('Request failed', options);
  }

  return new JSendError("Request returned an error: ".concat(jsend.message), options);
}

function pick(props, obj) {
  return props.reduce(function (acc, key) {
    if (!obj.hasOwnProperty(key)) return acc;
    return Object.assign(acc, _defineProperty({}, key, obj[key]));
  }, {});
}

export default apply;
export { JSendError };
